<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>Chapitre 3. Modification du code source</title>
    <link rel="stylesheet" type="text/css" href="debian.css"/>
    <meta name="generator" content="DocBook XSL Stylesheets V1.78.1"/>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <link rel="home" href="index.fr.html" title="Guide du nouveau responsable Debian"/>
    <link rel="up" href="index.fr.html" title="Guide du nouveau responsable Debian"/>
    <link rel="prev" href="first.fr.html" title="Chapitre 2. Premiers pas"/>
    <link rel="next" href="dreq.fr.html" title="Chapitre 4. Fichiers nécessaires dans le répertoire debian"/>
  </head>
  <body>
    <div class="navheader">
      <table width="100%" summary="Navigation header">
        <tr>
          <th colspan="3" align="center">Chapitre 3. Modification du code source</th>
        </tr>
        <tr>
          <td align="left"><a accesskey="p" href="first.fr.html"><img src="images/prev.png" alt="Précédent"/></a> </td>
          <th width="60%" align="center"> </th>
          <td align="right"> <a accesskey="n" href="dreq.fr.html"><img src="images/next.png" alt="Suivant"/></a></td>
        </tr>
      </table>
      <hr/>
    </div>
    <div class="chapter">
      <div class="titlepage">
        <div>
          <div>
            <h1 class="title"><a id="modify"/>Chapitre 3. Modification du code source</h1>
          </div>
        </div>
      </div>
      <div class="toc">
        <p>
          <strong>Table des matières</strong>
        </p>
        <dl class="toc">
          <dt>
            <span class="section">
              <a href="modify.fr.html#quiltrc">3.1. Configuration de <span class="command"><strong>quilt</strong></span></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="modify.fr.html#fixupstream">3.2. Correction de bogues amont</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="modify.fr.html#destdir">3.3. Installation des fichiers à leur emplacement</a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="modify.fr.html#difflibs">3.4. Bibliothèques différentes</a>
            </span>
          </dt>
        </dl>
      </div>
      <p>
La place manque pour entrer dans <span class="emphasis"><em>tous</em></span> les détails de
modification des sources amont, mais voici quelques étapes basiques et
quelques problèmes créant des difficultés.
</p>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="quiltrc"/>3.1. Configuration de <span class="command"><strong>quilt</strong></span></h2>
            </div>
          </div>
        </div>
        <p>
Le programme <span class="command"><strong>quilt</strong></span> fournit une méthode fondamentale pour
enregistrer les modifications du code source amont pour l'empaquetage
Debian. Il est utile d'avoir de légères personnalisations du paramétrage par
défaut, configurez donc un alias <span class="command"><strong>dquilt</strong></span> pour
l'empaquetage Debian en ajoutant les lignes suivantes à
<code class="filename">~/.bashrc</code>. La deuxième ligne fournit les mêmes
fonctionnalités de complétion de l’interpréteur pour la commande
<span class="command"><strong>dquilt</strong></span> que pour la commande <span class="command"><strong>quilt</strong></span> :
</p>
        <pre class="screen">
alias dquilt="quilt --quiltrc=${HOME}/.quiltrc-dpkg"
complete -F _quilt_completion $_quilt_complete_opt dquilt
</pre>
        <p>
Ensuite créez <code class="filename">~/.quiltrc-dpkg</code> comme suit :
</p>
        <pre class="screen">
d=. ; while [ ! -d $d/debian -a `readlink -e $d` != / ]; do d=$d/..; done
if [ -d $d/debian ] &amp;&amp; [ -z $QUILT_PATCHES ]; then
    # dans le cas d'une arborescence de paquet Debian avec $QUILT_PATCHES non configuré
    QUILT_PATCHES="debian/patches"
    QUILT_PATCH_OPTS="--reject-format=unified"
    QUILT_DIFF_ARGS="-p ab --no-timestamps --no-index --color=auto"
    QUILT_REFRESH_ARGS="-p ab --no-timestamps --no-index"
    QUILT_COLORS="diff_hdr=1;32:diff_add=1;34:diff_rem=1;31:diff_hunk=1;33:diff_ctx=35:diff_cctx=33"
    if ! [ -d $d/debian/patches ]; then mkdir $d/debian/patches; fi
fi
</pre>
        <p>
Consultez <span class="citerefentry"><span class="refentrytitle">quilt</span>(1)</span> et <code class="filename">/usr/share/doc/quilt/quilt.pdf.gz</code>
pour apprendre à utiliser <span class="command"><strong>quilt</strong></span>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="fixupstream"/>3.2. Correction de bogues amont</h2>
            </div>
          </div>
        </div>
        <p>
Si vous trouvez une erreur dans le <code class="filename">Makefile</code> amont comme
suit, où <code class="literal">install: gentoo</code> aurait dû être <code class="literal">install:
gentoo-target</code> :
</p>
        <pre class="screen">
install: gentoo
        install ./gentoo $(BIN)
        install icons/* $(ICONS)
        install gentoorc-example $(HOME)/.gentoorc
</pre>
        <p>
Corrigez l'erreur et enregistrez-la avec la commande
<span class="command"><strong>dquilt</strong></span> sous
<code class="filename">fix-gentoo-target.patch</code> : <a href="#ftn.idp38713600" class="footnote" id="idp38713600"><sup class="footnote">[22]</sup></a>
</p>
        <pre class="screen">
$ mkdir debian/patches
$ dquilt new fix-gentoo-target.patch
$ dquilt add Makefile
</pre>
        <p>
Modifiez le fichier <code class="filename">Makefile</code> comme suit :
</p>
        <pre class="screen">
install: gentoo-target
        install ./gentoo $(BIN)
        install icons/* $(ICONS)
        install gentoorc-example $(HOME)/.gentoorc
</pre>
        <p>
Demandez à <span class="command"><strong>dquilt</strong></span> de créer
<code class="filename">debian/patches/fix-gentoo-target.patch</code> et ajoutez sa
description conformément à <a class="ulink" href="http://dep.debian.net/deps/dep3/">DEP-3 : Directives pour
l'étiquetage des correctifs</a> :
</p>
        <pre class="screen">
$ dquilt refresh
$ dquilt header -e
... description du correctif
</pre>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="destdir"/>3.3. Installation des fichiers à leur emplacement</h2>
            </div>
          </div>
        </div>
        <p>
La plupart des logiciels tiers s'installent d'eux-mêmes dans le répertoire
<code class="filename">/usr/local</code>. Dans Debian, il est réservé à l'usage privé
de l'administrateur système, les paquets ne doivent donc pas utiliser de
répertoires comme <code class="filename">/usr/local/bin</code>, mais devraient plutôt
utiliser les répertoires système comme <code class="filename">/usr/bin</code>,
conformément à la norme de hiérarchie des fichiers (<a class="ulink" href="http://www.debian.org/doc/packaging-manuals/fhs/fhs-2.3.html">FHS</a>).
</p>
        <p>
Habituellement, <span class="citerefentry"><span class="refentrytitle">make</span>(1)</span> est utilisé pour automatiser la
construction du programme et l'exécution de <code class="literal">make install</code>
installe les programmes directement à l'endroit voulu (d'après la cible
<code class="literal">install</code> du <code class="filename">Makefile</code>). Pour permettre
à Debian de fournir des paquets installables préconstruits, il modifie le
système de construction pour installer les programmes dans une image de
l'arborescence de fichiers créée dans un répertoire temporaire plutôt que
dans la destination réelle.
</p>
        <p>
Ces deux différences entre l'installation normale du programme d'un côté et
le système d'empaquetage Debian de l'autre peuvent être abordées de façon
transparente par le paquet <code class="systemitem">debhelper</code>
à l'aide des commandes <span class="command"><strong>dh_auto_configure</strong></span> et
<span class="command"><strong>dh_auto_install</strong></span> si les conditions suivantes sont
vérifiées :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
le <code class="filename">Makefile</code> doit suivre les conventions GNU et gérer la
variable <code class="literal">$(DESTDIR)</code> ; <a href="#ftn.idp38732464" class="footnote" id="idp38732464"><sup class="footnote">[23]</sup></a>
</p>
            </li>
            <li class="listitem">
              <p>
les sources doivent suivre la norme de hiérarchie des fichiers (« Filesystem
Hierarchy Standard » ou FHS).
</p>
            </li>
          </ul>
        </div>
        <p>
Les programmes qui utilisent GNU <span class="command"><strong>autoconf</strong></span> suivent les
conventions GNU automatiquement, de telle sorte qu'ils peuvent être faciles
à empaqueter. Sur cette base et d'autres paramètres, on estime que le paquet
<code class="systemitem">debhelper</code> fonctionnera pour 90 % des
paquets sans modification intrusive de leur système de
construction. L'empaquetage n'est donc pas aussi compliqué qu'il y parait.
</p>
        <p>
Si vous devez modifier le <code class="filename">Makefile</code>, vous devriez vous
assurer qu'il gère la variable <code class="literal">$(DESTDIR)</code>. Bien qu'elle
ne soit pas configurée par défaut, la variable <code class="literal">$(DESTDIR)</code>
précède chaque chemin de fichier utilisé par le programme d'installation. Le
script d'empaquetage configurera <code class="literal">$(DESTDIR)</code> en tant que
répertoire temporaire. 
</p>
        <p>
Pour un paquet source créant un seul paquet binaire, le répertoire
temporaire utilisé par la commande <span class="command"><strong>dh_auto_install</strong></span> sera
configurée en
<code class="filename">debian/<em class="replaceable"><code>paquet</code></em></code>. <a href="#ftn.idp38741872" class="footnote" id="idp38741872"><sup class="footnote">[24]</sup></a> Le contenu du répertoire temporaire sera copié sur
le système de l'utilisateur qui installera votre paquet, la seule différence
est que <span class="command"><strong>dpkg</strong></span> placera ces fichiers dans des chemins
relatifs au répertoire racine plutôt qu'au répertoire de travail.
</p>
        <p>
Gardez à l'esprit que même si le programme s'installe dans
<code class="filename">debian/<em class="replaceable"><code>paquet</code></em></code>, il doit
continuer à s'exécuter correctement quand il est installé à partir du paquet
<code class="filename">.deb</code> sous le répertoire racine. Vous ne devez donc pas
laisser le système de construction coder en dur des chaînes de caractères
comme
<code class="literal">/home/moi/deb/<em class="replaceable"><code>paquet</code></em>-<em class="replaceable"><code>version</code></em>/usr/share/<em class="replaceable"><code>paquet</code></em></code>
dans les fichiers du paquet.
</p>
        <p>
Voici les parties concernées du <code class="filename">Makefile</code> de <code class="systemitem">gentoo</code> <a href="#ftn.idp38755728" class="footnote" id="idp38755728"><sup class="footnote">[25]</sup></a> :
</p>
        <pre class="screen">
# Emplacement des commandes exécutables lors de « make install »
BIN     = /usr/local/bin
# Emplacement des icônes lors de « make install »
ICONS   = /usr/local/share/gentoo
</pre>
        <p>
Les fichiers sont configurés pour s'installer sous
<code class="filename">/usr/local/</code>. Conformément aux explications précédentes,
ce répertoire est réservé pour les utilisations locales de Debian, changez
donc ces chemins en :
</p>
        <pre class="screen">
# Emplacement des commandes exécutables lors de « make install »
BIN     = $(DESTDIR)/usr/bin
# Emplacement des icônes lors de « make install »
ICONS   = $(DESTDIR)/usr/share/gentoo
</pre>
        <p>
Les emplacements exacts qui devraient être utilisés pour les exécutables,
icônes, documentation, etc., sont décrits dans la norme de hiérarchie des
fichiers (FHS). Vous devriez la consulter et lire les sections relatives à
votre paquet.
</p>
        <p>
Dès lors, les commandes exécutables devraient être installées sous
<code class="filename">/usr/bin</code> plutôt que sous
<code class="filename">/usr/local/bin</code>, la page de manuel sous
<code class="filename">/usr/share/man/man1</code> plutôt que sous
<code class="filename">/usr/local/man/man1</code> et ainsi de suite. Remarquez qu'il
n'y a pas de page de manuel mentionnée dans le fichier
<code class="filename">Makefile</code> de <code class="systemitem">gentoo</code>, mais comme la Charte Debian exige que
chaque programme en ait une, il faudra en créer une plus tard et l'installer
dans <code class="filename">/usr/share/man/man1</code>.
</p>
        <p>
Certains programmes n'utilisent pas les variables des fichiers
<code class="filename">Makefile</code> pour définir des chemins comme ceux-ci. Cela
signifie que vous risquez de devoir modifier de vrais fichiers sources C
pour qu'ils utilisent les emplacements corrects. Mais où, et que chercher
exactement ? Vous pouvez le découvrir avec :
</p>
        <pre class="screen">
$ grep -nr --include='*.[c|h]' -e 'usr/local/lib' .
</pre>
        <p>
<span class="command"><strong>grep</strong></span> va parcourir récursivement l'arbre des sources et
donner le nom des fichiers et le numéro des lignes où il trouve une
occurrence.
</p>
        <p>
Modifiez ces fichiers en remplaçant dans ces lignes,
<code class="literal">usr/local/lib</code> par <code class="literal">usr/lib</code>. Cela peut
être automatisé comme suit :
</p>
        <pre class="screen">
$ sed -i -e 's#usr/local/lib#usr/lib#g' \
        $(find . -type f -name '*.[c|h]')
</pre>
        <p>
Afin de confirmer toutes les substitutions, vous pouvez procéder de façon
interactive comme suit :
</p>
        <pre class="screen">
$ vim '+argdo %s#usr/local/lib#usr/lib#gce|update' +q \
        $(find . -type f -name '*.[c|h]')
</pre>
        <p>
Ensuite, vous devriez trouver la cible <code class="literal">install</code> (chercher
la ligne qui commence par <code class="literal">install:</code> fonctionne en général)
et renommez toutes les références aux répertoires autres que ceux définis au
début du <code class="filename">Makefile</code>.
</p>
        <p>
À l'origine, la cible <code class="literal">install</code> de <code class="systemitem">gentoo</code> était de la forme :
</p>
        <pre class="screen">
install: gentoo-target
        install ./gentoo $(BIN)
        install icons/* $(ICONS)
        install gentoorc-example $(HOME)/.gentoorc
</pre>
        <p>
Corrigez ce bogue amont et enregistrez la modification avec la commande
<span class="command"><strong>dquilt</strong></span> sous
<code class="filename">debian/patches/install.patch</code> :
</p>
        <pre class="screen">
$ dquilt new install.patch
$ dquilt add Makefile
</pre>
        <p>
Dans votre éditeur, modifiez cela pour le paquet Debian comme suit :
</p>
        <pre class="screen">
install: gentoo-target
        install -d $(BIN) $(ICONS) $(DESTDIR)/etc
        install ./gentoo $(BIN)
        install -m644 icons/* $(ICONS)
        install -m644 gentoorc-example $(DESTDIR)/etc/gentoorc
</pre>
        <p>
Vous aurez remarqué qu'il y a maintenant une commande <code class="literal">install
-d</code> avant les autres dans la règle. Elle n'existait pas dans le
<code class="filename">Makefile</code> d'origine parce qu'habituellement
<code class="literal">/usr/local/bin</code> et les autres répertoires existent déjà
sur le système dans lequel <code class="literal">make install</code> est
exécuté. Cependant, puisque dans notre cas l'installation se fait dans une
arborescence spécifique nouvellement créée, chacun de ces répertoires doit
être créé.
</p>
        <p>
D'autres choses peuvent être ajoutés à la fin de la règle, comme
l'installation de la documentation additionnelle que l'auteur amont oublie
parfois :
</p>
        <pre class="screen">
        install -d $(DESTDIR)/usr/share/doc/gentoo/html
        cp -a docs/* $(DESTDIR)/usr/share/doc/gentoo/html
</pre>
        <p>
Vérifiez soigneusement, et si tout est bon, demandez à
<span class="command"><strong>dquilt</strong></span> de créer le correctif
<code class="filename">debian/patches/install.patch</code> et ajoutez sa description
:
</p>
        <pre class="screen">
$ dquilt refresh
$ dquilt header -e
... description du correctif
</pre>
        <p>
Vous avez maintenant un ensemble de correctifs.
</p>
        <div class="orderedlist">
          <ol class="orderedlist">
            <li class="listitem">
              <p>
correction d'un bogue amont :
<code class="filename">debian/patches/fix-gentoo-target.patch</code> ;
</p>
            </li>
            <li class="listitem">
              <p>
modification spécifique à l'empaquetage Debian :
<code class="filename">debian/patches/install.patch</code> ;
</p>
            </li>
          </ol>
        </div>
        <p>
Chaque fois que vous faites des modifications qui ne sont pas spécifiques à
Debian comme <code class="filename">debian/patches/fix-gentoo-target.patch</code>,
envoyez-les au responsable amont pour qu'elles puissent être intégrées dans
la version suivante du programme et que tout le monde puisse en
profiter. Évitez aussi de faire des corrections spécifiques à Debian ou
Linux — ou même UNIX ! Faites-les portables. Cela rendra vos corrections
beaucoup plus faciles à appliquer.
</p>
        <p>
Remarquez que vous ne devez pas envoyer les fichiers
<code class="filename">debian/*</code> en amont.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="difflibs"/>3.4. Bibliothèques différentes</h2>
            </div>
          </div>
        </div>
        <p>
Il y a un autre problème courant : des bibliothèques sont souvent
différentes d'une plate-forme à l'autre. Par exemple,
<code class="filename">Makefile</code> peut contenir une référence à une bibliothèque
qui n'existe pas sur le système Debian. Dans ce cas, remplacez-la par une
bibliothèque qui existe dans Debian, et qui sert à la même chose.
</p>
        <p>
Supposons qu'une ligne de <code class="filename">Makefile</code> (ou
<code class="filename">Makefile.in</code>) du programme comme suit :
</p>
        <pre class="screen">
LIBS = -ltruc -lbidule
</pre>
        <p>
Si votre programme ne compile pas depuis que la bibliothèque
<code class="literal">truc</code> n'existe plus et que son équivalent est fournie par
la bibliothèque <code class="literal">truc2</code> sur le système Debian, vous pouvez
corriger ce problème de construction en
<code class="filename">debian/patches/truc2.patch</code> en modifiant
<code class="literal">truc</code> en <code class="literal">truc2</code> : <a href="#ftn.idp38801040" class="footnote" id="idp38801040"><sup class="footnote">[26]</sup></a>
</p>
        <pre class="screen">
$ dquilt new truc2.patch
$ dquilt add Makefile
$ sed -i -e 's/-ltruc/-ltruc2/g' Makefile
$ dquilt refresh
$ dquilt header -e
... description du correctif
</pre>
      </div>
      <div class="footnotes">
        <br/>
        <hr/>
        <div id="ftn.idp38713600" class="footnote">
          <p><a href="#idp38713600" class="para"><sup class="para">[22] </sup></a> Le répertoire <code class="filename">debian/patches</code> devrait maintenant exister
si vous avez exécuté <span class="command"><strong>dh_make</strong></span> comme décrit auparavant. Cet
exemple de manipulation le crée seulement si vous mettez à jour un paquet
existant.  </p>
        </div>
        <div id="ftn.idp38732464" class="footnote">
          <p><a href="#idp38732464" class="para"><sup class="para">[23] </sup></a> Consultez les <a class="ulink" href="http://www.gnu.org/prep/standards/html_node/DESTDIR.html#DESTDIR">normes GNU de codage :
7.2.4 DESTDIR : prise en charge des installations détournées</a> ;</p>
        </div>
        <div id="ftn.idp38741872" class="footnote">
          <p><a href="#idp38741872" class="para"><sup class="para">[24] </sup></a> Pour un paquet source créant plusieurs paquets binaires, la commande
<span class="command"><strong>dh_auto_install</strong></span> utilise <code class="filename">debian/tmp</code>
comme répertoire temporaire alors que la commande
<span class="command"><strong>dh_install</strong></span>, à l'aide des fichiers
<code class="filename">debian/<em class="replaceable"><code>paquet-1</code></em>.install</code> et
<code class="filename">debian/<em class="replaceable"><code>paquet-2</code></em>.install</code>,
séparera le contenu de <code class="filename">debian/tmp</code> dans les répertoires
temporaires <code class="filename">debian/<em class="replaceable"><code>paquet-1</code></em></code>
et <code class="filename">debian/<em class="replaceable"><code>paquet-2</code></em></code> pour
créer les paquets binaires
<code class="filename"><em class="replaceable"><code>paquet-1</code></em>_*.deb</code> et
<code class="filename"><em class="replaceable"><code>paquet-2</code></em>_*.deb</code>
</p>
        </div>
        <div id="ftn.idp38755728" class="footnote">
          <p><a href="#idp38755728" class="para"><sup class="para">[25] </sup></a> Il s'agit simplement d'un exemple pour montrer à quoi le
<code class="filename">Makefile</code> devrait ressembler. Si le
<code class="filename">Makefile</code> est créé par la commande
<span class="command"><strong>./configure</strong></span>, la bonne façon de modifier ce genre de
<code class="filename">Makefile</code> est d'exécuter <span class="command"><strong>./configure</strong></span>
à partir de la commande <span class="command"><strong>dh_auto_configure</strong></span> avec les
options par défaut y compris <code class="literal">--prefix=/usr</code>.  </p>
        </div>
        <div id="ftn.idp38801040" class="footnote">
          <p><a href="#idp38801040" class="para"><sup class="para">[26] </sup></a>Si des modifications de l'API existent entre les bibliothèques
<code class="literal">truc</code> et <code class="literal">truc2</code>, les modifications
nécessaires au code source doivent être faites pour correspondre à la
nouvelle API.</p>
        </div>
      </div>
    </div>
    <div class="navfooter">
      <hr/>
      <table width="100%" summary="Navigation footer">
        <tr>
          <td align="left"><a accesskey="p" href="first.fr.html"><img src="images/prev.png" alt="Précédent"/></a> </td>
          <td align="center"> </td>
          <td align="right"> <a accesskey="n" href="dreq.fr.html"><img src="images/next.png" alt="Suivant"/></a></td>
        </tr>
        <tr>
          <td align="left" valign="top">Chapitre 2. Premiers pas </td>
          <td align="center">
            <a accesskey="h" href="index.fr.html">
              <img src="images/home.png" alt="Sommaire"/>
            </a>
          </td>
          <td align="right" valign="top"> Chapitre 4. Fichiers nécessaires dans le répertoire <code class="filename">debian</code></td>
        </tr>
      </table>
    </div>
  </body>
</html>
